<?php
namespace WallaceInline;

require_once('default-filters.php');
require_once('operators.php');

use Rx\Observable;
use Rx\ObserverInterface;
use Rx\SchedulerInterface; 
use Rx\Operator\OperatorInterface;
use Rx\Operator\toWallaceFieldStream;
use WP_REST_Request;

final class FieldFactory{
	private static $hasFields;
	private static $fields;
	private static $rows;


	private function __construct(){
		$this->setup();
	}

	public static function getInstance(){
		static $inst = null;
        if ($inst === null) {
            $inst = new FieldFactory();
        }
        return $inst;
	}

	public function currentPageHasEditableFields(){
		return self::$hasFields;
	}

	public function getFields(){
		return array_merge(self::$fields, self::$rows);
	}

	private function setup(){

		$beaverBuilderStream = Observable::create(function (ObserverInterface $observer){
			add_action( 'fl_builder_after_render_module', function($module) use ($observer){
				//  print '<script>console.log(' . json_encode($module) . ');</script>';

				$observer->onNext($module);
			}, 10, 1);
			// add_action( 'fl_builder_after_render_row', function($row) use ($observer){
				// print '<script>console.log(' . json_encode($row) . ');</script>';

			// 	$observer->onNext($row);
			// }, 10, 1);
			add_action('wp_footer', function() use($observer){
				// print '<script>console.log(' . json_encode('done') . ');</script>';
				$observer->onCompleted();
			}, 8, 0);
		});

		$rowStream = Observable::create(function (ObserverInterface $observer){
		
			add_action( 'fl_builder_after_render_row_bg', function($row) use ($observer){
				// print '<script>console.log(' . json_encode($row) . ');</script>';

				$observer->onNext($row);
			}, 10, 1);
			add_action('wp_footer', function() use($observer){
				// print '<script>console.log(' . json_encode('done') . ');</script>';
				$observer->onCompleted();
			}, 8, 0);
		});


		// $beaverBuilderStream->subscribe(function($item){
		// 	print '<script>console.log(' . json_encode($item) . ');</script>';

		// });
		

		// $beaverBuilderStream
		// 	->take(1)	
		// 	->subscribe(function($item){ //subscribe to only first item then shutdown and give hasFields = true
		// 		self::$hasFields = true;
		// 		// print '<script>console.log(' . json_encode(self::$hasFields) . ');</script>';
		// 	});

		$rowStream
			->toWallaceFieldStream()
			->toArray()
			->subscribe(function($fields){
				self::$rows = $fields;
				// print '<script>console.log(' . json_encode(self::$rows) . ');</script>';


			});

		$beaverBuilderStream
			->toWallaceFieldStream()
			->toArray()
			->subscribe(function($fields){

				// $fieldsToPublish = array_map(function($field){
				// 	if($field['uiType'] === 'media'){
				// 		return array('field' => $field, 'data' => '40'); //40 38
				// 	}
				// 	if($field['uiType'] === 'icon'){
				// 		return array('field' => $field, 'data' => 'fas fa-arrow-circle-up'); // fas fa-arrow-circle-up
				// 	}
				// 	if($field['uiType'] === 'link'){
				// 		return array('field' => $field, 'data' => 'https://twitter.com'); // https://google.com
				// 	}

				// 	return array('field' => $field, 'data' => (string)random_int(1, 10000));
				// }, $fields);

				// $request = new WP_REST_Request('POST', '/wallaceinline/v2/publish');
				// $request->set_body(json_encode($fieldsToPublish));
				// $request->set_header('X-Post-Id', '2');
				// $response = rest_do_request($request);

				self::$fields = $fields;
				if(sizeof(self::$fields) > 0){
					self::$hasFields = true;
				}

				// print '<script>var wallaceInline = '. json_encode(self::$fields) .'</script>';
				// print '<script>console.log(' . json_encode(self::$fields) . ');</script>';
				// print '<script>console.log(' . json_encode($response) . ');</script>';

			});
	}




}









?>